/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.45 from the
 * contents of Util.xs. Do not edit this file, edit Util.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Util.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#define dsDEBUG 0
#if dsDEBUG
#  define dsWARN(msg)  warn(msg)
#else
#  define dsWARN(msg)
#endif
#define PTRLEN 40

int has_seen( SV * sv, HV * seen );
/*
   Generate a string containing the address,
   the flags and the Sv type
*/

SV *
_get_infos( SV * sv ) {
    return newSVpvf( "%p-%x-%x", sv, SvFLAGS( sv ) & ~SVf_OOK,
                     SvTYPE( sv ) );
}

/*

Upgrade strings to utf8

*/
bool
_utf8_set( SV * sv, HV * seen, int onoff ) {
    I32 len, i;
    HV *myHash;
    HE *HEntry;
    SV **AValue;

    /* if this is a plain reference then simply
       move down to what the reference points at */

  redo_utf8:
    if ( SvROK( sv ) ) {
        if ( has_seen( sv, seen ) )
            return TRUE;
        sv = SvRV( sv );
        goto redo_utf8;
    }

    switch ( SvTYPE( sv ) ) {

        /* recursivly look inside a hash and arrays */

    case SVt_PVAV:{
            dsWARN( "Found array\n" );
            len = av_len( ( AV * ) sv );
            for ( i = 0; i <= len; i++ ) {
                AValue = av_fetch( ( AV * ) sv, i, 0 );
                if ( AValue )
                    _utf8_set( *AValue, seen, onoff );
            }
            break;
        }
    case SVt_PVHV:{
            dsWARN( "Found hash\n" );
            myHash = ( HV * ) sv;
            hv_iterinit( myHash );
            while (( HEntry = hv_iternext( myHash ) )) {
                _utf8_set( HeVAL( HEntry ), seen, onoff );
            }
            break;
        }

        /* non recursive case, check if it's got a string
           value or not. */

    default:{
            if ( SvPOK( sv ) ) {
                /* it's a string! do the transformation if we need to */

                dsWARN( "string (PV)\n" );
                dsWARN( SvUTF8( sv ) ? "UTF8 is on\n" : "UTF8 is off\n" );
                if ( onoff && !SvUTF8( sv ) ) {
                    sv_utf8_upgrade( sv );
                }
                else if ( !onoff && SvUTF8( sv ) ) {
                    sv_utf8_downgrade( sv, 0 );
                }
            }
            else {
                /* unknown type.  Could be a SvIV or SvNV, but they don't
                   have magic so that's okay.  Could also be one of the
                   types we don't deal with (a coderef, a typeglob) */

                dsWARN( "unknown type\n" );
            }
        }
    }
    return TRUE;
}

/*

Change utf8 flag

*/
bool
_utf8_flag_set( SV * sv, HV * seen, int onoff ) {
    I32 i, len;
    HV *myHash;
    HE *HEntry;
    SV **AValue;

    /* if this is a plain reference then simply
       move down to what the reference points at */

  redo_flag_utf8:
    if ( SvROK( sv ) ) {
        if ( has_seen( sv, seen ) )
            return TRUE;
        sv = SvRV( sv );
        goto redo_flag_utf8;
    }

    switch ( SvTYPE( sv ) ) {

        /* recursivly look inside a hash and arrays */

    case SVt_PVAV:{
            dsWARN( "Found array\n" );
            len = av_len( ( AV * ) sv );
            for ( i = 0; i <= len; i++ ) {
                AValue = av_fetch( ( AV * ) sv, i, 0 );
                if ( AValue )
                    _utf8_flag_set( *AValue, seen, onoff );
            }
            break;
        }
    case SVt_PVHV:{
            dsWARN( "Found hash\n" );
            myHash = ( HV * ) sv;
            hv_iterinit( myHash );
            while (( HEntry = hv_iternext( myHash ) )) {
                _utf8_flag_set( HeVAL( HEntry ), seen, onoff );
            }
            break;
        }

        /* non recursive case, check if it's got a string
           value or not. */

    default:{

            /* it's a string! do the transformation if we need to */

            if ( SvPOK( sv ) ) {
                dsWARN( "string (PV)\n" );
                dsWARN( SvUTF8( sv ) ? "UTF8 is on\n" : "UTF8 is off\n" );
                if ( onoff && !SvUTF8( sv ) ) {
                    SvUTF8_on( sv );
                }
                else if ( !onoff && SvUTF8( sv ) ) {
                    SvUTF8_off( sv );
                }
            }
            else {

                /* unknown type.  Could be a SvIV or SvNV, but they don't
                   have magic so that's okay.  Could also be one of the
                   types we don't deal with (a codref, a typeglob) */

                dsWARN( "unknown type\n" );
            }
        }
    }
    return TRUE;
}

/*

Returns true if sv contains a utf8 string

*/
bool
_has_utf8( SV * sv, HV * seen ) {
    I32 i, len;
    SV **AValue;
    HV *myHash;
    HE *HEntry;

  redo_has_utf8:
    if ( SvROK( sv ) ) {
        if ( has_seen( sv, seen ) )
            return FALSE;
        sv = SvRV( sv );
        goto redo_has_utf8;
    }

    switch ( SvTYPE( sv ) ) {

    case SVt_PV:
    case SVt_PVNV:{
            dsWARN( "string (PV)\n" );
            dsWARN( SvUTF8( sv ) ? "UTF8 is on\n" : "UTF8 is off\n" );
            if ( SvUTF8( sv ) ) {
                dsWARN( "Has UTF8\n" );
                return TRUE;
            }
            break;
        }
    case SVt_PVAV:{
            dsWARN( "Found array\n" );
            len = av_len( ( AV * ) sv );
            for ( i = 0; i <= len; i++ ) {
                AValue = av_fetch( ( AV * ) sv, i, 0 );
                if ( AValue && _has_utf8( *AValue, seen ) )
                    return TRUE;
            }
            break;
        }
    case SVt_PVHV:{
            dsWARN( "Found hash\n" );
            myHash = ( HV * ) sv;
            hv_iterinit( myHash );
            while (( HEntry = hv_iternext( myHash ) )) {
                if ( _has_utf8( HeVAL( HEntry ), seen ) )
                    return TRUE;
            }
            break;
        }
    default: ;
    }
    return FALSE;
}

/*

unbless any object within the data structure

*/
SV *
_unbless( SV * sv, HV * seen ) {
    I32 i, len;
    SV **AValue;
    HV *myHash;
    HE *HEntry;

  redo_unbless:
    if ( SvROK( sv ) ) {

        if ( has_seen( sv, seen ) )
            return sv;

        if ( sv_isobject( sv ) ) {
            sv = ( SV * ) SvRV( sv );
            SvOBJECT_off( sv );
        }
        else {
            sv = ( SV * ) SvRV( sv );
        }
        goto redo_unbless;
    }

    switch ( SvTYPE( sv ) ) {

    case SVt_PVAV:{
            dsWARN( "an array\n" );
            len = av_len( ( AV * ) sv );
            for ( i = 0; i <= len; i++ ) {
                AValue = av_fetch( ( AV * ) sv, i, 0 );
                if ( AValue )
                    _unbless( *AValue, seen );
            }
            break;
        }
    case SVt_PVHV:{
            dsWARN( "a hash (PVHV)\n" );
            myHash = ( HV * ) sv;
            hv_iterinit( myHash );
            while (( HEntry = hv_iternext( myHash ) )) {
                _unbless( HeVAL( HEntry ), seen );
            }
            break;
        }
    default: ;
    }
    return sv;
}

/*

Returns objects within a data structure, deep first

*/
AV *
_get_blessed( SV * sv, HV * seen, AV * objects ) {
    I32 i;
    SV **AValue;
    HV *myHash;
    HE *HEntry;

    if ( SvROK( sv ) ) {

        if ( has_seen( sv, seen ) )
            return objects;
        _get_blessed( SvRV( sv ), seen, objects );
        if ( sv_isobject( sv ) ) {
            (void) SvREFCNT_inc( sv );
            av_push( objects, sv );
        }

    }
    else {

        switch ( SvTYPE( sv ) ) {
        case SVt_PVAV:{
                for ( i = 0; i <= av_len( ( AV * ) sv ); i++ ) {
                    AValue = av_fetch( ( AV * ) sv, i, 0 );
                    if ( AValue )
                        _get_blessed( *AValue, seen, objects );
                }
                break;
            }
        case SVt_PVHV:{
                myHash = ( HV * ) sv;
                hv_iterinit( myHash );
                while (( HEntry = hv_iternext( myHash ) )) {
                    _get_blessed( HeVAL( HEntry ), seen, objects );
                }
                break;
            }
        default: ;
        }
    }

    return objects;
}

/*

Returns references within a data structure, deep first

*/
AV *
_get_refs( SV * sv, HV * seen, AV * objects ) {
    I32 i;
    SV **AValue;
    HV *myHash;
    HE *HEntry;
    if ( SvROK( sv ) ) {

        if ( has_seen( sv, seen ) )
            return objects;
        _get_refs( SvRV( sv ), seen, objects );
        (void) SvREFCNT_inc( sv );
        av_push( objects, sv );

    }
    else {

        switch ( SvTYPE( sv ) ) {
        case SVt_PVAV:{
                for ( i = 0; i <= av_len( ( AV * ) sv ); i++ ) {
                    AValue = av_fetch( ( AV * ) sv, i, 0 );
                    if ( AValue )
                        _get_refs( *AValue, seen, objects );
                }
                break;
            }
        case SVt_PVHV:{
                myHash = ( HV * ) sv;
                hv_iterinit( myHash );
                while (( HEntry = hv_iternext( myHash ) )) {
                    _get_refs( HeVAL( HEntry ), seen, objects );
                }
                break;
            }
        default: ;
        }
    }
    return objects;
}

/*

Returns a signature of the structure

*/
AV *
_signature( SV * sv, HV * seen, AV * infos ) {
    I32 i;
    U32 len;
    SV **AValue;
    HV *myHash;
    HE *HEntry;
    char *HKey;

  testvar1:

    if ( SvROK( sv ) ) {
        if ( has_seen( sv, seen ) )
            return infos;

        av_push( infos, _get_infos( sv ) );
        sv = SvRV( sv );
        goto testvar1;

    }
    else {

        av_push( infos, _get_infos( sv ) );
        switch ( SvTYPE( sv ) ) {
        case SVt_PVAV:
            for ( i = 0; i <= av_len( ( AV * ) sv ); i++ ) {
                AValue = av_fetch( ( AV * ) sv, i, 0 );
                if ( AValue )
                    _signature( *AValue, seen, infos );
            }
            break;

        case SVt_PVHV:
            myHash = ( HV * ) sv;
            hv_iterinit( myHash );
            while (( HEntry = hv_iternext( myHash ) )) {
                STRLEN len;
                HKey = HePV( HEntry, len );
                _signature( HeVAL( HEntry ), seen, infos );
            }
            break;
        default: ;
        }
    }
    return infos;
}

/*

Detects if there is a circular reference

*/
SV *
_has_circular_ref( SV * sv, HV * parents, HV * seen ) {

    SV *ret;
    SV *found;
    U32 len;
    I32 i;
    SV **AValue;
    HV *myHash;
    HE *HEntry;
    SV **HValue;
#if dsDEBUG
    char errmsg[100];
#endif

    if ( SvROK( sv ) ) {        /* Reference */

        char addr[PTRLEN];
        sprintf( addr, "%p", SvRV( sv ) );
        len = strlen( addr );

        if ( hv_exists( parents, addr, len ) ) {
#ifdef SvWEAKREF
            if ( SvWEAKREF( sv ) ) {
                dsWARN( "found a weak reference" );
                return &PL_sv_undef;
            }
            else {
#endif
                dsWARN( "found a circular reference!!!" );
                (void) SvREFCNT_inc( sv );
                return sv;
#ifdef SvWEAKREF
            }
#endif
        }
        if ( hv_exists( seen, addr, len ) ) {
            dsWARN( "circular reference on weak ref" );
            return &PL_sv_undef;
        }

        (void) hv_store( parents, addr, len, NULL, 0 );
        (void) hv_store( seen, addr, len, NULL, 0 );
#ifdef SvWEAKREF
        if ( SvWEAKREF( sv ) ) {
            dsWARN( "found a weak reference 2" );
            ret = _has_circular_ref( SvRV( sv ), newHV(  ), seen );
        }
        else {
#endif
            ret = _has_circular_ref( SvRV( sv ), parents, seen );
#ifdef SvWEAKREF
        }
#endif
        (void) hv_delete( seen, addr, ( U32 ) len, 0 );
        (void) hv_delete( parents, addr, ( U32 ) len, 0 );
        return ret;
    }

    /* Not a reference */
    switch ( SvTYPE( sv ) ) {

    case SVt_PVAV:{            /* Array */
            dsWARN( "Array" );
            for ( i = 0; i <= av_len( ( AV * ) sv ); i++ ) {
#if dsDEBUG
                sprintf( errmsg, "next elem %i\n", i );
                warn( errmsg );
#endif
                AValue = av_fetch( ( AV * ) sv, i, 0 );
                if ( AValue ) {
                    found = _has_circular_ref( *AValue, parents, seen );
                    if ( SvOK( found ) )
                        return found;
                }
            }
            break;
        }
    case SVt_PVHV:{            /* Hash */
            dsWARN( "Hash" );
            myHash = ( HV * ) sv;
            hv_iterinit( myHash );
            while (( HEntry = hv_iternext( myHash ) )) {
#if dsDEBUG
                STRLEN len2;
                char *HKey = HePV( HEntry, len2 );
                sprintf( errmsg, "NEXT KEY is %s\n", HKey );
                warn( errmsg );
#endif
                found =
                    _has_circular_ref( HeVAL( HEntry ), parents, seen );
                if ( SvOK( found ) )
                    return found;
            }
            break;
        }
    default: ;
    }
    return &PL_sv_undef;
}

/*

Weaken any circular reference found

*/
SV *
_circular_off( SV * sv, HV * parents, HV * seen, SV * counter ) {

    U32 len;
    I32 i;
    SV **AValue;
    HV *myHash;
    HE *HEntry;
    char addr[PTRLEN];
#if dsDEBUG
    char errmsg[100];
#endif

    if ( SvROK( sv ) ) {        /* Reference */

        sprintf( addr, "%p", SvRV( sv ) );
        len = strlen( addr );

        if ( hv_exists( parents, addr, len ) ) {
            if ( SvWEAKREF( sv ) ) {
                dsWARN( "found a weak reference" );
            }
            else {
                dsWARN( "found a circular reference!!!" );
                sv_rvweaken( sv );
                sv_inc( counter );
            }
        }
        else {

            if ( hv_exists( seen, addr, len ) ) {
                dsWARN( "circular reference on weak ref" );
                return &PL_sv_undef;
            }

            (void) hv_store( parents, addr, len, NULL, 0 );
            (void) hv_store( seen, addr, len, NULL, 0 );
#ifdef SvWEAKREF
            if ( SvWEAKREF( sv ) ) {
                dsWARN( "found a weak reference 2" );
                _circular_off( SvRV( sv ), newHV(  ), seen, counter );
            }
            else {
#endif
                _circular_off( SvRV( sv ), parents, seen, counter );
#ifdef SvWEAKREF
            }
#endif
            (void) hv_delete( seen, addr, ( U32 ) len, 0 );
            (void) hv_delete( parents, addr, ( U32 ) len, 0 );
        }

    }
    else {

        /* Not a reference */
        switch ( SvTYPE( sv ) ) {

        case SVt_PVAV:{        /* Array */
                dsWARN( "Array" );
                for ( i = 0; i <= av_len( ( AV * ) sv ); i++ ) {
#if dsDEBUG
                    sprintf( errmsg, "next elem %i\n", i );
                    warn( errmsg );
#endif
                    AValue = av_fetch( ( AV * ) sv, i, 0 );
                    if ( AValue ) {
                        _circular_off( *AValue, parents, seen, counter );
                        if ( SvTYPE( sv ) != SVt_PVAV ) {
                            /* In some circumstances, weakening a reference screw things up */
                            croak
                                ( "Array that we were weakening suddenly turned into a scalar of type type %d",
                                  SvTYPE( sv ) );
                        }
                    }
                }
                break;
            }
        case SVt_PVHV:{        /* Hash */
                dsWARN( "Hash" );
                myHash = ( HV * ) sv;
                hv_iterinit( myHash );
                while (( HEntry = hv_iternext( myHash ) )) {
#if dsDEBUG
                    STRLEN len2;
                    char *HKey = HePV( HEntry, len2 );
                    sprintf( errmsg, "NEXT KEY is %s\n", HKey );
                    warn( errmsg );
#endif
                    _circular_off( HeVAL( HEntry ), parents, seen,
                                   counter );
                    if ( SvTYPE( sv ) != SVt_PVHV ) {
                        /* In some circumstances, weakening a reference screw things up */
                        croak
                            ( "Hash that we were weakening suddenly turned into a scalar of type type %d",
                              SvTYPE( sv ) );
                    }
                }
                break;
            }
        default: ;
        }
    }
    return counter;
}

#if dsDEBUG
/*

Dump any data structure

*/

SV *
_dump_any( SV * re, HV * seen, int depth ) {

  testvar:

    if ( SvROK( re ) ) {
        if ( has_seen( re, seen ) )
            return re;
        printf( "a reference " );

        if ( sv_isobject( re ) )
            printf( " blessed " );

        printf( "to " );
        re = SvRV( re );
        goto testvar;

    }
    else {

        switch ( SvTYPE( re ) ) {
        case SVt_NULL:
            printf( "an undef value\n" );
            break;
        case SVt_IV:
            printf( "an integer (IV): %d\n", SvIV( re ) );
            break;
        case SVt_NV:
            printf( "a double (NV): %f\n", SvNV( re ) );
            break;
        case SVt_RV:
            printf( "a RV\n" );
            break;
        case SVt_PV:
            printf( "a string (PV): %s\n", SvPV_nolen( re ) );
            printf( "UTF8 %s\n", SvUTF8( re ) ? "on" : "off" );
            break;
        case SVt_PVIV:
            printf( "an integer (PVIV): %d\n", SvIV( re ) );
            break;
        case SVt_PVNV:
            printf( "a string (PVNV): %s\n", SvPV_nolen( re ) );
            printf( "UTF8 %s\n", SvUTF8( re ) ? "on" : "off" );
            break;
        case SVt_PVMG:
            printf( "a PVMG\n" );
            break;
        case SVt_PVLV:
            printf( "a PVLV\n" );
            break;
        case SVt_PVAV:
            {
                I32 i;

                printf( "an array of %u elems (PVAV)\n",
                        av_len( ( AV * ) re ) + 1 );
                for ( i = 0; i <= av_len( ( AV * ) re ); i++ ) {
                    SV **AValue = av_fetch( ( AV * ) re, i, 0 );
                    if ( AValue ) {
                        printf( "NEXT ELEM is " );
                        _dump_any( *AValue, seen, depth );
                    }
                    else {
                        printf( "NEXT ELEM was undef" );
                    }
                }
                break;
            }

        case SVt_PVHV:
            {
                HV *myHash = ( HV * ) re;
                HE *HEntry;
                int count = 0;

                printf( "a hash (PVHV)\n" );
                hv_iterinit( myHash );
                while ( HEntry = hv_iternext( myHash ) ) {
                    STRLEN len;
                    char *HKey = HePV( HEntry, len );
                    int i;

                    count++;
                    for ( i = 0; i < depth; i++ )
                        printf( "\t" );
                    printf( "NEXT KEY is %s, value is ", HKey );
                    _dump_any( HeVAL( HEntry ), seen, depth + 1 );
                }
                if ( !count )
                    printf( "Empty\n" );
                break;
            }

        case SVt_PVCV:
            printf( "a code (PVCV)\n" );
            return;
        case SVt_PVGV:
            printf( "a glob (PVGV)\n" );
            break;
        case SVt_PVBM:
            printf( "a PVBM\n" );
            break;
        case SVt_PVFM:
            printf( "a PVFM\n" );
            break;
        case SVt_PVIO:
            printf( "a PVIO\n" );
            break;
        default:
            if ( SvOK( re ) ) {
                printf( "Don't know what it is\n" );
                return;
            }
            else {
                croak( "Not a Sv" );
                return;
            }
        }
    }
    return re;
}
#endif

/*
 has_seen
 Returns true if ref already seen
*/
int
has_seen( SV * sv, HV * seen ) {
    char addr[PTRLEN];
    sprintf( addr, "%p", SvRV( sv ) );
    if ( hv_exists( seen, addr, ( U32 ) strlen( addr ) ) ) {
        dsWARN( "already seen" );
        return TRUE;
    }
    else {
        (void) hv_store( seen, addr, ( U32 ) strlen( addr ), NULL, 0 );
        return FALSE;
    }
}

/* *INDENT-OFF* */

#line 810 "Util.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 954 "Util.c"

XS_EUPXS(XS_Data__Structure__Util_utf8_off_xs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__Structure__Util_utf8_off_xs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV*	sv = ST(0)
;
	bool	RETVAL;
#line 807 "Util.xs"
    _utf8_set(sv, (HV*) sv_2mortal((SV*) newHV()), 0);
#line 968 "Util.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__Structure__Util_utf8_on_xs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__Structure__Util_utf8_on_xs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV*	sv = ST(0)
;
	bool	RETVAL;
#line 817 "Util.xs"
    RETVAL = _utf8_set(sv, (HV*) sv_2mortal((SV*) newHV()), 1);
#line 986 "Util.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__Structure__Util__utf8_off_xs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__Structure__Util__utf8_off_xs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV*	sv = ST(0)
;
	bool	RETVAL;
#line 829 "Util.xs"
    _utf8_flag_set(sv, (HV*) sv_2mortal((SV*) newHV()), 0);
#line 1005 "Util.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__Structure__Util__utf8_on_xs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__Structure__Util__utf8_on_xs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV*	sv = ST(0)
;
	bool	RETVAL;
#line 839 "Util.xs"
    RETVAL = _utf8_flag_set(sv, (HV*) sv_2mortal((SV*) newHV()), 1);
#line 1023 "Util.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__Structure__Util_has_utf8_xs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__Structure__Util_has_utf8_xs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV*	sv = ST(0)
;
	bool	RETVAL;
#line 851 "Util.xs"
    RETVAL = _has_utf8(sv, (HV*) sv_2mortal((SV*) newHV()));
#line 1042 "Util.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__Structure__Util_unbless_xs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__Structure__Util_unbless_xs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV*	sv = ST(0)
;
	SV *	RETVAL;
#line 863 "Util.xs"
    _unbless(sv, (HV*) sv_2mortal((SV*) newHV()));
#line 1061 "Util.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__Structure__Util_has_circular_ref_xs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__Structure__Util_has_circular_ref_xs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV*	sv = ST(0)
;
	SV *	RETVAL;
#line 873 "Util.xs"
    RETVAL = _has_circular_ref(sv, (HV*) sv_2mortal((SV*) newHV()), (HV*) sv_2mortal((SV*) newHV()));
#line 1079 "Util.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__Structure__Util_circular_off_xs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__Structure__Util_circular_off_xs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV*	sv = ST(0)
;
	SV *	RETVAL;
#line 885 "Util.xs"
#ifdef SvWEAKREF
#else
    croak("This version of perl doesn't support weak references");
#endif
    RETVAL = _circular_off(sv, (HV*) sv_2mortal((SV*) newHV()), (HV*) sv_2mortal((SV*) newHV()), newSViv(0));
#line 1103 "Util.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__Structure__Util_get_blessed_xs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__Structure__Util_get_blessed_xs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV*	sv = ST(0)
;
	AV *	RETVAL;
#line 901 "Util.xs"
    RETVAL = _get_blessed(sv, (HV*) sv_2mortal((SV*) newHV()), (AV*) sv_2mortal((SV*) newAV()));
#line 1123 "Util.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__Structure__Util_get_refs_xs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__Structure__Util_get_refs_xs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV*	sv = ST(0)
;
	AV *	RETVAL;
#line 913 "Util.xs"
    RETVAL = _get_refs(sv, (HV*) sv_2mortal((SV*) newHV()), (AV*) sv_2mortal((SV*) newAV()));
#line 1147 "Util.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__Structure__Util_signature_xs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__Structure__Util_signature_xs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV*	sv = ST(0)
;
	AV *	RETVAL;
#line 925 "Util.xs"
    RETVAL = _signature(sv, (HV*) sv_2mortal((SV*) newHV()), (AV*) sv_2mortal((SV*) newAV()));
#line 1171 "Util.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Data__Structure__Util); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Data__Structure__Util)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Data::Structure::Util::utf8_off_xs", XS_Data__Structure__Util_utf8_off_xs, file, "$");
        (void)newXSproto_portable("Data::Structure::Util::utf8_on_xs", XS_Data__Structure__Util_utf8_on_xs, file, "$");
        (void)newXSproto_portable("Data::Structure::Util::_utf8_off_xs", XS_Data__Structure__Util__utf8_off_xs, file, "$");
        (void)newXSproto_portable("Data::Structure::Util::_utf8_on_xs", XS_Data__Structure__Util__utf8_on_xs, file, "$");
        (void)newXSproto_portable("Data::Structure::Util::has_utf8_xs", XS_Data__Structure__Util_has_utf8_xs, file, "$");
        (void)newXSproto_portable("Data::Structure::Util::unbless_xs", XS_Data__Structure__Util_unbless_xs, file, "$");
        (void)newXSproto_portable("Data::Structure::Util::has_circular_ref_xs", XS_Data__Structure__Util_has_circular_ref_xs, file, "$");
        (void)newXSproto_portable("Data::Structure::Util::circular_off_xs", XS_Data__Structure__Util_circular_off_xs, file, "$");
        (void)newXSproto_portable("Data::Structure::Util::get_blessed_xs", XS_Data__Structure__Util_get_blessed_xs, file, "$");
        (void)newXSproto_portable("Data::Structure::Util::get_refs_xs", XS_Data__Structure__Util_get_refs_xs, file, "$");
        (void)newXSproto_portable("Data::Structure::Util::signature_xs", XS_Data__Structure__Util_signature_xs, file, "$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

